#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    size_t number_count, bin_count, max_bin, height;
    double maxx, minn;
    cerr << "Enter number count: "; cin >> number_count; //- 

    vector <double> numbers(number_count);
    for (int i = 0; i < number_count; i++)
    {
        cerr << "Enter Num[" << i << "]: "; cin >> numbers[i]; // 
    }
    cerr << "Enter bin count: "; cin >> bin_count; //- 

    vector <size_t> bins(bin_count);
    maxx = numbers[0]; minn = numbers[1];
    for (size_t i = 0; i < number_count; i++)
    {
        if (maxx < numbers[i])
            maxx = numbers[i];
        if (minn > numbers[i])
            minn = numbers[i];
    }

    double bin_size = (maxx - minn) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = minn + j * bin_size;
            auto hi = minn + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    max_bin = bins[0];
    height = bins[0];
    for (size_t i = 0; i < bin_count; i++)
    {
        if (bins[i] > max_bin)
            max_bin = bins[i];
    }

    bool flag = false;
    if ( max_bin > 80)
    {
        flag = true;
    }
    for (size_t i = 0; i < bin_count; i++)
    {
        if (bins[i] < 100)
            cout << " ";
        if (bins[i] < 10)
            cout << " ";
        cout << bins[i] << "|";
        if( flag == true)
        {
            height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_bin);
        }
        else
        {
            height = bins[i];
        }
        for (size_t j = 0; j < height; j++)
        {
            cout << "*";
        }
        cout << endl;
        if ((bin_count - i) != 1)
            cout << minn + bin_size * (i+1) << endl;
    }
    return 0;
}
